;;;  example of key bind

(oglwin '.gl)
(pack  .gl) 

(define *dlist* (.gl 'newlist))
(.gl 'eval
          :newlist *dlist* 'compile
	:clearcolor 0 0 0 0
        :ortho -1 1 -1 1 -1 1
	:clear 'colorbuffer  'depthbuffer 
        :color 1 0 1
        :begin 'polygon
            :vertex -0.4  -0.2 :vertex  -0.05 -0.2
            :vertex -0.05  0.0 :vertex  -0.4   0.0
        :end
        :endlist
)

(define (move-box x y)
   (.gl 'main     
        :matrixmode 'modelview
        :loadidentity
        :translate x y 0
        :call *dlist*
   )
)

(move-box 0 0)

(define *x* 0)
(define *y* 0)
;;;    .gl catn't catch key event
(bind |.| "<KeyPress>"
      (lambda (K)
         (cond ((equal? K "Left") (dec *x* 0.1)(move-box *x* *y*))
               ((equal? K "Right") (inc *x* 0.1)(move-box *x* *y*))
               ((equal? K "Up") (inc *y* 0.1)(move-box *x* *y*))
               ((equal? K "Down") (dec  *y* 0.1)(move-box *x* *y*))
         )
       )
)

(bind .gl "<Button-3>" (lambda()(bye)))


