;;;;  Caution!st
;;;  Never use  define for tk-variables
;;; for example 
;;;  (define img ())
;;; then img is only used in stk , and can't get tk-function  bind!!!
;;;;;

(define redisplay
    (lambda()
       (.gl 'main :matrixmode 'projection
            :loadidentity
            :perspective 30 1 0.1 10
            :matrixmode 'modelview
            :loadidentity
            :lookat -3 2 3  0 0 0  0 1 0
            :clear 'depthbuffer 'colorbuffer
            :rotate yrot 1 1 0 :call dlist :call dlist2)
        (set! yrot (+  yrot 5))
        (after 20 '(redisplay))
    )
)

(pack (oglwin '.gl :width 300 :height 300)
        :side 'left :expand 'yes :fill 'both)


(image 'create 'photo 'img :file "logo128.gif")


(.gl 'eval 
	:enable 'depthtest 
	:texparameter 'texture2d 'texturewraps 'repeat
	:texparameter 'texture2d 'texturewrapt 'repeat 
	:texparameter 'texture2d 'texturemagfilter 'nearest 
	:texparameter 'texture2d 'textureminfilter 'nearest 
	;;   :texenv 'textureenv 'textureenvmode 'modulate
	:texenv 'textureenv 'textureenvmode 'replace
	:texgen 's 'objectplane  1 0 0 0
	:texgen 't 'objectplane  0 0 1 0
	:shademodel 'smooth 
	:enable 'texture2d 
	:light 'light0 'ambient 1 1 1 1 
	:light 'light0 'diffuse 1 1 1 1 
	:light 'light0 'position 1 1 1 0 
	:light 'light0 'specular 1 1 1 1 
	:enable 'lighting :enable 'light0 
	:material 'front 'ambient 0.4 0.4 0.4 
	:material 'front 'diffuse 0.5 0.5 0.5 
	:material 'front 'specular 0.5 0.5 0.5 
	:material 'front 'shininess 50 
	:enable 'depthtest 
	:enable 'lighting
)

(define dlist (.gl 'newlist))
(.gl 'eval
          :newlist dlist 'compile
        :teximage2d 0 0 'img
        :begin 'polygon
        :texcoord 0.0 0.0 :vertex -0.5  -0.5 
        :texcoord 0.0 1.0 :vertex -0.5  0.5 
        :texcoord 1.0 1.0 :vertex 0.5  0.5 
        :texcoord 1.0 0.0 :vertex 0.5 -0.5 
        :end
        :endlist
)

(image 'create 'photo 'img2 :file "dol256.gif")

(define dlist2 (.gl 'newlist))

(.gl 'eval
          :newlist dlist2 'compile
         :teximage2d 0 0 'img2
        :begin 'polygon
        :texcoord 0.0 0.0 :vertex 0.5  -0.5 0.0
        :texcoord 0.0 1.0 :vertex 0.5  0.5  0.0
        :texcoord 1.0 1.0 :vertex 1.0 0.3   0.5
        :texcoord 1.0 0.0 :vertex 1.0 -0.3  0.5
        :end
        :endlist
)

(define yrot 0)
(redisplay)


