/***   tk_ssconv.c
***/
#define  TK_SSCONV_C

#include "lisp.h"
#include <tcl.h>
/****  tk_ssconv.c  2004.9.5 created    ***/
/****  convert  ss-obj  ->  tk-obj  string  ****/
/***     divided from   tk_conversion.c   ****/

extern int euc_first(),conv_level;

ptr ss_tkstr();
static ptr list_tk_simple(),list_tk();

int count_quote(char *p,int n){
unsigned int c,s=0;
   while(n-->0){
     c=*p++;
    if(euc_first(c)){
        p++;
        n--;
    }
    else if(c=='"'||c=='{'||c=='}'){ 
          s++;
    }
   }
return s;
}

int check_kanji(unsigned char *p,int n){
 unsigned int s=0;
   while(n--){
    if(euc_first(*p++)){
       s=1;
       break;
    }
   }
return s;
}


static ptr ss_cmd(ptr x,ptr env){
  ptr res;
    res=a_str_ss;  /*** make_str_c("ss "); ***/
       psh(res);
       x=objaddress(x);
       psh(x);
       res=*(stack-1)=str_append(res,x);
       *(stack-2)=x=number2str(MAKESINT(conv_level),10);
       res=*(stack-1)=str_append(res,a_str_space);
       res=*(stack-1)=str_append(res,x);
       res=ss_tkstr(res,env,NO);  /*** need {}  ***/ 
       stack-=2;
       return res;
}

static ptr ss_cmd_bind(ptr x,ptr env){
  ptr res,b,memo=x;
 int n;
 extern int bind_plus;
 extern ptr bind_func,k_LB,assq();
    /*** if((n&SLAMBDA)!=LAMBDA){ ***/
        if(x==CAR(a_plus)){
             /****    +(lambda (x y) .....)   ****/
           bind_plus=YES;
           return a_nullstr;
        } 
    n=FTYPE(x);
     if((n&LAMBDA)==0)
           return a_undef;
        /***  error(E_illegal,x);   No error , only ignore  
            because of TCL return value  ****/
   /**  } **/
    /*** if(n&ALLOC){ ** MC-function ***/
    if(ATTR(x)==SR2){ /*** SR2-function ***/
        b=FENV(x);
        b=CDR(assq(k_LB,b));
       /***
        printf("bind MC ");
        prin1(b,STDOUT);
       ***/
     }
    else{   /***  lambda  ***/    
       /***  ?????    Need?    ***/
      b=FBODY(x);
      b=CAR(b);  /**** args   ***/
    }
    res=a_str_ss;  /*** make_str_c("ss "); ***/
       psh(res);
      if(bind_plus==YES){
         *(stack-1)=res=str_append(PNAME(a_plus),a_str_space);
         *(stack-1)=res=str_append(res,a_str_ss);
         }
       x=objaddress(x);
       psh(x);
       res=*(stack-1)=str_append(res,x);
       *(stack-2)=x=number2str(MAKESINT(conv_level),10);
       res=*(stack-1)=str_append(res,a_str_space);
       x=*(stack-1)=str_append(res,x);
       while(CONSP(b)){
          x=*(stack-1)=str_append(x,a_str_percent);
          x=*(stack-1)=str_append(x,PNAME(CAR(b)));
          b=CDR(b);
       }
        x=ss_tkstr(x,env,NO); /*** needs {} ***/ 
       stack-=2;
      bind_func=memo;  /*****  to know bind lambda, check in tk_eval   ****/
       return x;
}

/****    ---->  utf8.c    05.1.15
ptr EUC_UTF(char *p,int n){
 ptr s;
 Tcl_DString argString;
 p=Tcl_ExternalToUtfDString(NULL, p, n, &argString);
 s=make_str_c(p);
 Tcl_DStringFree(&argString);
 return s;
}
****/


/*** convert ss-obj  to TCL-obj ***/
/***  ss_flag is used for :command  obj ***/
static ptr number2str_tcl(ptr x){
   /***   2/3 -> 0.6666    04.5.3 ***/
 if(!SINTP(x)&&RATIOP(x)){
   x=MAKEDBL(get_float(x));
   psh(x);
   x=number2str(x,10);
   pull();
   return x;
 }
   return number2str(x,10);
}

ptr ss_tkstr_simple(ptr x,ptr env,int lev){
 ptr res;
 Reg char *p,*q;
 unsigned int n,c;
  ptr assq();

 if(SINTP(x)) return  number2str(x,10);
 if(CHARP(x)) return  makestring_init(1,CHAR_CODE(x));
 if(NUMBERP(x)) return  number2str_tcl(x);
 if(STRINGP(x)){
   p=get_string(x,&n);
   if(check_kanji(p,n)){
      /*** return EUC_UTF(p,n); ***/
      return EUC_UTF(x);
   }
   else
      return x;
}

 if(SYMBOLP(x)) return PNAME(x);
 if(KEYWORDP(x)) {
     x=copy_str(PNAME(x));
     p=get_string(x,&n);
     *p='-';
     /*** change :borderWidth -> -borderwidth ***/
     while(--n){
       c=*++p;
       *p=tolower(c);
     }
     return x;
  }
 if(CONSP(x)){
      return list_tk_simple(x,env,lev);
  }
 if(x==a_t) return  number2str(ONE,10);
 if(x==a_f) return  number2str(ZERO,10);
 if(x==a_nil) return a_nullstr; /*** 04.4.24  ***/

  if(CLOSUREP(x)){
   n=FTYPE(x);
   if(n&TKFUNC){
       x=CDR(assq(k_widget_name,FENV(x)));
       return PNAME(x);
    }
 }

  sprintf(iobuff,"*** conversion error *****  %x\n",x);
  lwritestr(STDERR,iobuff);
  prin1(x,STDERR);
 return a_nullstr; /*** error ***/
}

ptr ss_tkstr(ptr x,ptr env,int ss_flag){  /***  ss cmd -> tcl cmd ***/
 ptr res;
 Reg char *p,*q;
 unsigned int n,c;
  ptr assq(),list_tk();

 if(SINTP(x)) return  number2str(x,10);
 if(CHARP(x)) return  makestring_init(1,CHAR_CODE(x));
 if(NUMBERP(x)) return  number2str_tcl(x);
 if(STRINGP(x)){
   p=get_string(x,&n);
   /***  if(*p=='{') return x;  Ȥꤢ  to be check syntax!!!  ****/
   res=makestring(n+2+count_quote(p,n));
   q=get_string(res,&n);
   p=get_string(x,&n);
   *q++='{';
   while(n-->0){
     c=*p++;
    if(euc_first(c)){
        *q++=c;
        *q++=*p++;
        n--;
    }
    else if(c=='"'||c=='{'||c=='}'){
          *q++='\\';
          *q++=c;
    }
    else 
        *q++=c;
   }
   *q='}';
   return res;
}
 if(SYMBOLP(x)) return copy_str(PNAME(x));
 if(KEYWORDP(x)) {
     x=copy_str(PNAME(x));
     p=get_string(x,&n);
     *p='-';
     /*** change :borderWidth -> -borderwidth ***/
     while(--n){
       c=*++p;
       *p=tolower(c);
     } 
     return x;
  }
 if(CLOSUREP(x)){
   n=FTYPE(x);
   if(n&TKFUNC){
       x=CDR(assq(k_widget_name,FENV(x)));
       return copy_str(PNAME(x));
    }
   if(ss_flag){   /***  to be modified !***/
    return ss_cmd(x,env);
   }
   /*** bind procedure  ***/
   return ss_cmd_bind(x,env);
 } 
 if(CONSP(x)){
    if(ss_flag){
        return ss_cmd(x,env);
      }
    else
      return list_tk(x,env);
  }
 if(x==a_t) return  number2str(ONE,10);
 if(x==a_f) return  number2str(ZERO,10);
 return a_nullstr; /*** 04.4.24  ***/
 /*** mada
 if(FUNCP(x))Y
***/
 /*** return a_undef;  this cause  E_notstr error  04.4.24 **/
}

ptr s_ss_tkstr(int narg,ptr env){
checknarg(narg-1);
return ss_tkstr(*(stack-1),env,NO);
}

static ptr list_tk(ptr x,ptr env){
  ptr res,arg;
   
   if(SREGP(CDR(x))||!CONSP(CDR(x))){   /****  (1 . 0) text index ***/
     return list_tk_simple(x,env,NO);
  }
   res=a_str_left;  /** make_str_c("{"); ***/
       psh(res);
       psh(res);
  while(CONSP(x)){
       *(stack-1)=res=str_append(res,a_str_space); /*** make_str_c(" ")); ***/
       *(stack-2)=arg=ss_tkstr(CAR(x),env,NO);
       *(stack-1)=res=str_append(res,arg);
       x=CDR(x);
  }
 *(stack-2)=arg=a_str_right; /*** make_str_c(" }"); ***/
 res=str_append(res,arg);
 stack-=2;
 return res;
}

static ptr list_tk_simple2(ptr x,ptr env){
  ptr res,arg;
   if(x==a_nil) return a_nullstr;
   res=a_str_left;  /** make_str_c("{"); ***/
       psh(res);
       psh(res);
  while(CONSP(x)){
       *(stack-2)=arg=ss_tkstr_simple(CAR(x),env,1);
       *(stack-1)=res=str_append(res,arg);
       x=CDR(x);
       if(x==a_nil) break;
       *(stack-1)=res=str_append(res,a_str_space); /*** make_str_c(" ")); ***/
  }
 res=str_append(res,a_str_right);
 stack-=2;
 return res;
}

static ptr list_tk_simple(ptr x,ptr env,int lev){
  ptr res,arg;
   if(x==a_nil) return a_nullstr;
   if(SREGP(CDR(x))||!CONSP(CDR(x))){   /****  (1 . 0) text index ***/
       res=ss_tkstr_simple(CAR(x),env,0);
       psh(res);
       *(stack-1)=res=str_append(res,PNAME(a_dot));
       arg=ss_tkstr_simple(CDR(x),env,0);
       psh(arg);
       res=str_append(res,arg);
       stack-=2;
       return res;
   }

      if(lev) return list_tk_simple2(x,env);
       res=ss_tkstr_simple(CAR(x),env,++lev);
       psh(res);
       psh(res);
       x=CDR(x);
  while(CONSP(x)){
       *(stack-1)=res=str_append(res,a_str_space); /*** make_str_c(" ")); ***/
       *(stack-2)=arg=ss_tkstr_simple(CAR(x),env,lev);
       *(stack-1)=res=str_append(res,arg);
       x=CDR(x);
  }
 stack-=2;
 return res;
}


