/****  assq   ***/
#define ASSQ_PROG
#include "lisp.h"
#define NOTLIST(x)  (SREGP(x)||(ATOM(x)&&(x!=a_nil)))

ptr assq(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(x==CAR(q)) return q;
   p=CDR(p);
}
return a_f;
}
/*** for safty.  Not used  ***/
static ptr safe_assq(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
  if((!SREGP(q))&&(CONSP(q))){
   if(x==CAR(q)) return q;
  }
   p=CDR(p);
}
return a_f;
}

/*** return second ***/
ptr assq2(ptr x,ptr lis){
 Reg ptr p=lis,q;
 Reg int second=0;
 while(CONSP(p)){
   q=CAR(p);
   if(x==CAR(q)){
      if(second++) return q;
   }
   p=CDR(p);
}
return a_f;
}


ptr rassq(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(x==CDR(q)) return q;
   p=CDR(p);
}
return a_f;
}

ptr assv(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(eqv(x,CAR(q))!=a_f) return q;
   p=CDR(p);
}
return a_f;
}

ptr rassv(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(eqv(x,CDR(q))!=a_f) return q;
   p=CDR(p);
}
return a_f;
}


ptr assoc(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(equal(x,CAR(q))!=a_f) return q;
   p=CDR(p);
}
return a_f;
}

ptr rassoc(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(equal(x,CDR(q))!=a_f) return q;
   p=CDR(p);
}
return a_f;
}

ptr member(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(equal(x,q)!=a_f) return p;
   p=CDR(p);
}
return a_f;
}

ptr memv(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while(CONSP(p)){
   q=CAR(p);
   if(eqv(x,q)!=a_f) return p;
   p=CDR(p);
}
return a_f;
}



ptr memq(ptr x,ptr lis){
 Reg ptr p=lis,q;
 while((!SREGP(p))&&(CONSP(p))){
   q=CAR(p);
   if(x==q) return p;
   p=CDR(p);
}
return a_f;
}

ptr remq(ptr x,ptr lis){
 Reg ptr p=lis,q,res;
  psh(res=get_cell());
 while((!SREGP(p))&&(CONSP(p))){
   q=CAR(p);
   if(x!=q)
       res=CDR(res)=CONS(q,a_nil);
   p=CDR(p);
}
return CDR(*pull());
}

ptr remv(ptr x,ptr lis){
 Reg ptr p=lis,q,res;
  psh(res=get_cell());
 while((!SREGP(p))&&(CONSP(p))){
   q=CAR(p);
   if(eqv(x,q)==a_f)
       res=CDR(res)=CONS(q,a_nil);
   p=CDR(p);
}  
return CDR(*pull());
}  

ptr ssremove(ptr x,ptr lis){
 Reg ptr p=lis,q,res;
  psh(res=get_cell());
 while((!SREGP(p))&&(CONSP(p))){
   q=CAR(p);
   if(equal(x,q)==a_f)
       res=CDR(res)=CONS(q,a_nil);
   p=CDR(p);
}
return CDR(*pull());
}



ptr s_assq(int narg,ptr env){  
   Reg ptr x,y;
   Reg int n=0;
   x=*(stack-2);
   y=*(stack-1);
   /* printf("leq %x %x \n ",x,y); */
   checknarg(narg-2);
   if(NOTLIST(y)) error(E_notlist,y); 
   return assq(x,y);
}  

ptr s_rassq(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   x=*(stack-2);
   y=*(stack-1);
   /* printf("leq %x %x \n ",x,y); */
   checknarg(narg-2);
   if(NOTLIST(y)) error(E_notlist,y);
   return rassq(x,y);
}

ptr s_assv(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   if(NOTLIST(y)) error(E_notlist,y); 
   return assv(x,y);
}

ptr s_rassv(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   if(NOTLIST(y)) error(E_notlist,y);
   return rassv(x,y);
}


ptr s_assoc(int narg,ptr env){  
   Reg ptr x,y;
   Reg int n=0;
   x=*(stack-2);
   y=*(stack-1);
   checknarg(narg-2);
   if(NOTLIST(y)) error(E_notlist,y); 
   return assoc(x,y);
}  

ptr s_rassoc(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   x=*(stack-2);
   y=*(stack-1);
   checknarg(narg-2);
   if(NOTLIST(y)) error(E_notlist,y);
   return rassoc(x,y);
}

ptr s_memq(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   return memq(x,y);
}


ptr s_member(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   return member(x,y);
}

ptr s_memv(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   return memv(x,y);
}

ptr s_remq(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   if(y==a_nil) return y;
   if(!CONSP(y)) return error(E_notlist,y);
   return remq(x,y);
}


ptr s_remove(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   if(y==a_nil) return y;
   if(!CONSP(y)) return error(E_notlist,y);
   return ssremove(x,y);
}

ptr s_remv(int narg,ptr env){
   Reg ptr x,y;
   Reg int n=0;
   checknarg(narg-2);
   x=*(stack-2);
   y=*(stack-1);
   if(y==a_nil) return y;
   if(!CONSP(y)) return error(E_notlist,y);
   return remv(x,y);
}


