/**** intern.c ***/
/**** 04.5.9   packafge version start  ***/
#define INTERN_PROG
#include "lisp.h"
#define HPACKAGE      ATOMVAL(a_package)


int gensym=1;  /***  for gensym  ***/
char gname[100];
int  genchar1='A';
int  genchar='A';

static int s_found;

ptr intern_c_pack();
extern ptr k_intern();


ptr intern_c( char *str, ptr val)
{
    return intern_c_pack(str,val,HPACKAGE);
}

ptr intern_c_pack( char *str, ptr val,ptr home)
{
    ptr  c,x;
    /** printf("intern_c str %s %x\n",str,home); ***/
    c=CMAKESTR(str);
    psh(c);
    x=ss_find_symbol(c,home);
     /*** printf("intern_c str %s find %x\n",str,x); ***/
  if(x==a_f){
     x=in_intern(c,home,val);
     pull();
      /***  printf("intern_c create return %x\n",x); ***/
    s_found=0;
    return x;
    }
  pull();
  s_found=1;
  return x;
}


ptr s_gensym(int narg,ptr env){
ptr x;
int n;
    n=gensym;
again:
  sprintf(gname,"%c%c%d",genchar1,genchar,++n);
  /** x=intern_c_pack(gname,a_undef,alias_package); **/
  x=intern_c(gname,a_undef);
  if(s_found) goto again;
  gensym=n;
  if(n>9998){
     if(genchar<122){
         gensym=1;
         genchar++;
         if(genchar==91) genchar=97; /** skip 91-96 , 91==[ !!!**/
      }
     else if (genchar1<122){
         genchar1++;
         if(genchar1==91) genchar1=97; /** skip 91-96 , 91==[ !!!**/
         gensym=1;
         genchar='A';
     }
    else
         ;
  }
  return x;
}

ptr intern( ptr str, ptr val)
{
  ptr home,x;
    home=HPACKAGE;
    x=ss_find_symbol(str,home);
    /*** printf("intern  str %x home %x find %x\n",str,home,x); **/
    if(x==a_f)
        x=in_intern(str,home,val);
   return x;
}

/***   top symbol access from C   ***/

ptr key_intern( ptr str)  /***  keyword , not symbol! ***/
{
   /****  ܥ:ޤ뤳Ȥ϶ػߤ롣  ***/
    ptr   c;
  c=k_intern(str,key_package,a_nil);
  /** printf("key_intern %x\n",c); **/
/***
if(ATTR(c)==KEYWORD) return c;
   ATTR(c)=KEYWORD;
   CAR(c)=c;
***/
   return c;
}


ptr key_intern_c( char *p)  /***  keyword , not symbol! ***/
{
   /****  ܥ:ޤ뤳Ȥ϶ػߤ롣  ***/
    ptr   c;
  /*** printf("key_intern enter %s\n",p); ***/
  c=CMAKESTR(p);
  psh(c);
  c=key_intern(c);
  pull();
  return c;
}


ptr s_symbol_string(int narg,ptr env){
Reg ptr x;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!SYMBOLP(x)) error(E_notsymb,x);
 return copy_str(PNAME(x));
}

ptr s_keyword_string(int narg,ptr env){
Reg ptr x;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!KEYWORDP(x)) error(E_keyword,x);
 return copy_str(PNAME(x));
} 


ptr s_string_symbol(int narg,ptr env){
Reg ptr x;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
 return intern(x,a_unbdd);
}

ptr s_string_keyword(int narg,ptr env){
Reg ptr x;
int n;
char *p;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
 p=get_string(x,&n);
 if(*p!=':') error(E_illegal,x);
 return key_intern(x);
}


ptr M_top_value_set(ptr s,ptr val){
 Reg ptr tk;
 Reg ptr trace=0;
  tk=SVAL(s);
 if(tk==a_unbdd)
      error( E_unbdd,s); /***  to be detail   ***/
  if(ATOMVAL(a_tracevars)!=a_nil){
     trace=assq(s,ATOMVAL(a_tracevars));
     if(trace==a_f) trace=(ptr)0;
  }
#ifdef USE_TK
  if(!SREGP(tk)&&(ATTR(tk)&TKOBJ)){
   set_tklink(tk,val);
   return a_undef;
  }   
#endif      
 /***  constant  04.5.8  **/
 if(ATTR(CDR(s))&CONSTF) error(E_const,s);
 SVAL(s)=val;
   if(trace) trace_var_cmds(CDR(trace));
 return a_undef;
}

/****  string is interned?  ***/
ptr s_string_intern(int narg,ptr env){
Reg ptr x;
int n,h;
char *p;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
 return ss_find_symbol(x,HPACKAGE);
}

/***   symbol is defined?  ***/
ptr s_symbol_bind(int narg,ptr env){
Reg ptr x;
int n,h;
char *p;
 checknarg(narg-1);
 x=*(stack-1);
 if(SREGP(x)||!SYMBOLP(x)) error(E_notsymb,x);
 if(ATOMVAL(x)==a_unbdd) return a_f;
 return  a_t;
}

ptr s_symbol_value(int nar,ptr env){
Reg ptr x,v;
char *p;
 checknarg(nar-1);
 x=*(stack-1);
 if(SREGP(x)||!SYMBOLP(x)) error(E_notsymb,x);
 if((v=ATOMVAL(x))==a_unbdd)  error(E_unbdd,x);
 return load_top(x); /*** var.c ***/
}

/****  2004.4.6  New   for macro.ss  Not R5RS***/
ptr s_symbol_value_set(int nar,ptr env){
Reg ptr x,v,tk;
char *p;
 checknarg(nar-2);
 x=*(stack-2);
 if(SREGP(x)||!SYMBOLP(x)) error(E_notsymb,x);
 /*** if((v=ATOMVAL(x))==a_unbdd)  error(E_unbdd,x);   ***/
  tk=SVAL(x);
 if(tk==a_unbdd)  ATOMVAL(x)=a_nil;
 M_top_value_set(x,*(stack-1));
 /*** ATOMVAL(x)=*(stack-1); ***/
 return  x;
}

ptr s_symbol_value_setf(int nar,ptr env){
/*** Danger!!!  this will be deleted in  the future !!! ***/
Reg ptr x,v;
char *p;
 checknarg(nar-2);
 x=*(stack-2);
 if(SREGP(x)||!SYMBOLP(x)) error(E_notsymb,x);
 /*** if((v=ATOMVAL(x))==a_unbdd)  error(E_unbdd,x);   ***/
  ATOMVAL(x)=*(stack-1);  /***  No error occur,  define enable!!!  ***/ 
 return  x;
}


ptr s_constant(int narg,ptr env){
 ptr x;
   checknarg(narg-1);
   x=*(stack-1);
   if(SREGP(x)||!SYMBOLP(x))error(E_notsymb,x);
   x=CDR(x);
   ATTR(x)|=CONSTF;
   return *(stack-1);
}

ptr s_unconstant(int narg,ptr env){
 ptr x;
   checknarg(narg-1);
   x=*(stack-1);
   if(SREGP(x)||!SYMBOLP(x))error(E_notsymb,x);
   x=CDR(x);
   ATTR(x)&=~CONSTF;
   return *(stack-1);
}
  
ptr s_constantp(int narg,ptr env){
 ptr x;
   checknarg(narg-1);
   x=*(stack-1);
   if(SREGP(x)||!SYMBOLP(x))error(E_notsymb,x);
   x=CDR(x);
   return PRED(ATTR(x)&CONSTF);
}

