/*** random.c
    sslisp  03.09.16 
GMP version
***/
#include  "lisp.h"
extern mpz_t mpzwork1,mpzwork2;
static gmp_randstate_t rstate;
extern int xhash();   /*** hash.c ***/

init_rand()
 {
   gmp_randinit_default(rstate);
   gmp_randseed_ui(rstate,(long)a_nil);/*** maybe danger **/ 
  }
  
ptr s_make_random(int narg,ptr env)
 {
    /*   expr 1  */
    Reg ptr x=*(stack-1);
   /*** gmp_randseed_ui(rstate,(long)x); maybe danger **/ 
   gmp_randseed_ui(rstate,xhash(x));/*** maybe danger **/ 
   return a_undef;
 }
 
ptr s_random(int narg,ptr env)
 {
    ptr p;
    double s;
    unsigned long int n;
    if(narg==0) p=a_nil;
    else if(narg==1)
        p=*(stack-1);
    else
          checknarg(narg-1);
    /*** if(gsign(p)||zerop(p)) error(E_range,p); **/
    
    if(SINTP(p))
      {
         if(p==ZERO) error(E_range,p);
         mpz_set_ui(mpzwork2,SINT_NUMB(p));
         mpz_urandomm(mpzwork1,rstate,mpzwork2);
         n=mpz_get_ui(mpzwork1);
         return MAKESINT(n);
      }
    else if(BIGINTP(p))
      {
         mpz_urandomm(mpzwork1,rstate,BIGNUM(p));
         return mpz_check16(mpzwork1);
       }
    else if(p==a_nil||DOUBLEP(p))
      { 
         mpz_set_ui(mpzwork2,0xffffffff);
         mpz_urandomm(mpzwork1,rstate,mpzwork2);
         n=mpz_get_ui(mpzwork1);
         s=(double)n;
         s/=(double)(unsigned int)0xffffffff;
        return MAKEDBL(s);
       }
    else
       error(E_typemis,p);
 }
