#include "lisp.h"
/***  Now below are not used , by M  ***/
/*** #define MULTIVAL SYSREG[3]***/
extern ptr MULTIVAL;


ptr s_map(int narg,ptr env){
ptr f,x,res,v,*sfree,*memo,*memo2;
int n,out=0;
   memo2=stack;
   f=*(stack-narg);
   narg--;
   sfree=stack-narg;
   n=narg;
   while(narg--){*stack++=*sfree++;};
   sfree=stack-n;
   memo=stack;
   *stack++=res=CONS(a_nil,a_nil);
   narg=n;
   while(1){
     n=narg;
     /*** if(*sfree==a_nil) break; ***/
     while(n--){
      if(SSATOM(*sfree)){
         out=1;
         break;
      }
      psh(CAR(*sfree));
      *sfree++=CDR(*sfree);
      }
     if(out) break;
     sfree-=narg;
     v=funcall(f,narg,env);
       res=CDR(res)=CONS(v,a_nil);
       stack-=narg;
   }
  v=CDR(*memo);   
   stack=memo2;
  return v;
}
  
ptr s_foreach(int narg,ptr env){
ptr f,x,v,*sfree,*memo2;
int n,out=0;
   memo2=stack;
   f=*(stack-narg);
   narg--;
   sfree=stack-narg;
   n=narg;
   while(narg--){*stack++=*sfree++;};
   sfree=stack-n;
   narg=n;
   while(1){
     n=narg;
     /*** if(*sfree==a_nil) break; ***/
     while(n--){
      if(SSATOM(*sfree)){
         out=1;
         break;
      }
      psh(CAR(*sfree));
      *sfree++=CDR(*sfree);
      }
     if(out) break;
     sfree-=narg;
     v=funcall(f,narg,env);
       stack-=narg;
   }
   stack=memo2;
  return a_undef;
}

/*****  aux  map     see lib.ss ****/

ptr s_map_pair(int narg,ptr env){
ptr f,x,res,v,*sfree,*memo,*memo2;
int n,out=0;
   memo2=stack;
   f=*(stack-narg);
   narg--;
   sfree=stack-narg;
   n=narg;
   while(narg--){*stack++=*sfree++;};
   sfree=stack-n;
   memo=stack;
   *stack++=res=CONS(a_nil,a_nil);
   narg=n;
   while(1){
     n=narg;
     /*** if(*sfree==a_nil) break; ***/
     while(n--){
      if(SSATOM(*sfree)){
         out=1;
         break;
      }
      psh(*sfree);
      *sfree++=CDR(*sfree);
      }
     if(out) break;
     sfree-=narg;
     v=funcall(f,narg,env);
       res=CDR(res)=CONS(v,a_nil);
       stack-=narg;
   }
  v=CDR(*memo);
   stack=memo2;
  return v;
}

ptr s_foreach_pair(int narg,ptr env){
ptr f,x,v,*sfree,*memo2;
int n,out=0;
   memo2=stack;
   f=*(stack-narg);
   narg--;
   sfree=stack-narg;
   n=narg;
   while(narg--){*stack++=*sfree++;};
   sfree=stack-n;
   narg=n;
   while(1){
     n=narg;
     /*** if(*sfree==a_nil) break; ***/
     while(n--){
      if(SSATOM(*sfree)){
         out=1;
         break;
      }
      psh(*sfree);
      *sfree++=CDR(*sfree);
      }
     if(out) break;
     sfree-=narg;
     v=funcall(f,narg,env);
       stack-=narg;
   }
   stack=memo2;
  return a_undef;
}

ptr s_map_filter(int narg,ptr env){
ptr f,x,res,v,*sfree,*memo,*memo2;
int n,out=0;
   memo2=stack;
   f=*(stack-narg);
   narg--;
   sfree=stack-narg;
   n=narg;
   while(narg--){*stack++=*sfree++;};
   sfree=stack-n;
   memo=stack;
   *stack++=res=CONS(a_nil,a_nil);
   narg=n;
   while(1){
     n=narg;
     /*** if(*sfree==a_nil) break; ***/
     while(n--){
      if(SSATOM(*sfree)){
         out=1;
         break;
      }
      psh(CAR(*sfree));
      *sfree++=CDR(*sfree);
      }
     if(out) break;
     sfree-=narg;
     v=funcall(f,narg,env);
       if(v!=a_f)
            res=CDR(res)=CONS(v,a_nil);
       stack-=narg;
   }
  v=CDR(*memo);
   stack=memo2;
  return v;
}

ptr s_filter(int narg,ptr env){
ptr f,x,res,v,p,*sfree;
int n,out=0;
   checknarg(narg-2);
   sfree=stack;
   f=*(stack-2);
   p=*(stack-1);
   stack+=2;
   *sfree=res=CONS(a_nil,a_nil);
   while(1){
     /*** if(*sfree==a_nil) break; ***/
      if(SSATOM(p)){
         break;
      }
      x=*(stack-1)=CAR(p);
      p=CDR(p);
     v=funcall(f,1,env);
       if(v!=a_f)
            res=CDR(res)=CONS(x,a_nil);
   }
  v=CDR(*sfree);
   stack=sfree;
  return v;
}

ptr s_find(int narg,ptr env){
ptr f,x,v,p;
   checknarg(narg-2);
   f=*(stack-2);
   p=*(stack-1);
   psh(p);
   while(1){
     /*** if(*sfree==a_nil) break; ***/
      if(SSATOM(p)){
         break;
      }
      x=*(stack-1)=CAR(p);
      p=CDR(p);
     v=funcall(f,1,env);
       if(v!=a_f){
            pull();
             return x;
       }
   }
    pull();
  return a_f;
}

ptr s_assp(int narg,ptr env){
ptr f,x,v,p;
   checknarg(narg-2);
   f=*(stack-2);
   p=*(stack-1);
   psh(p);
   while(1){
     /*** if(*sfree==a_nil) break; ***/
      if(SSATOM(p)){
         break;
      }
      x=CAR(p);
      if(SSATOM(x)) error(E_notlist,x);
      *(stack-1)=CAR(x);
      p=CDR(p);
     v=funcall(f,1,env);
       if(v!=a_f){
            pull();
             return x;
       }
   }
    pull();
  return a_f;
}

ptr s_partition(int narg,ptr env){
ptr f,x,res,v,p,*sfree,res2;
int n,out=0;
   checknarg(narg-2);
   sfree=stack;
   f=*(stack-2);
   p=*(stack-1);
   stack+=3;
   *sfree=res=CONS(a_nil,a_nil);
   *(sfree+1)=res2=CONS(a_nil,a_nil);
   while(1){
     /*** if(*sfree==a_nil) break; ***/
      if(SSATOM(p)){
         break;
      }
      x=*(stack-1)=CAR(p);
      p=CDR(p);
     v=funcall(f,1,env);
       if(v==a_f)
            res2=CDR(res2)=CONS(x,a_nil);
       else
            res=CDR(res)=CONS(x,a_nil);
   }
  res=CDR(*sfree);
  res2=CDR(*(sfree+1));
       v= CONS(res2,a_nil);
       v= CONS(res,v);
  /***
   ATTR(v)=MULTI;
   multiscm=v;
   ***/
    MULTIVAL=v; /*** V2.0  **/
   stack=sfree;
  return res;
}

ptr s_find_tail(int narg,ptr env){
ptr f,v=a_f,p,*sfree;
int n,out=0;
   checknarg(narg-2);
   sfree=stack;
   f=*(stack-2);
   p=*(stack-1);
   stack++;
   while(1){
      if(SSATOM(p)){
         break;
      }
      *(stack-1)=CAR(p);
     v=funcall(f,1,env);
       if(v!=a_f)
             break;
      p=CDR(p);
   }
   stack=sfree;
   if(v==a_f)
        return v;
   return p;
}


