/***  token.c
***/
#define  TOKEN_C

#include "lisp.h"
#include <ctype.h>
#include <string.h>
#include "clread.h"

/****   analyze   token
   complex support 03.9.17
   revised 2004.7.29
   number  ->>> str2num.c
      ***/

extern int  base;
extern ptr makestring_p();

static ptr analyze2();
ptr pack_make_symbol();

chk_base()
 {
  Reg ptr p;
  Reg int n;
   p=ATOMVAL(a_read_base);
   if(SINTP(p)){
     n=getnum(p);
     if(n>=2&&n<=36) return n;
   }
   return 10;
 }
ptr analyze(Reg char *p){
    base=chk_base();
    return analyze2(p);
}

static ptr analyze2(Reg char *p){
 /**  Reg ptr str;   **  str-ptr ****/
   Reg ptr u;
      
#ifdef DEBUG
  /** printf(" analyze token %s\n",p);  **/
#endif
   /***  dot check ***/
   if(loc_tok==1){
       if(*p=='.') {
           rm_error=E_dot;
           return a_undef;
        }
   }    
   u=str2num(p);
   if(u!=a_f) return u;
   return   pack_make_symbol(p,loc_tok);
}

ptr pack_make_symbol(p,c)
  Reg char *p;
  Reg int c;
{
  Reg char *q,*r;
  Reg ptr pack,x,ret;
  extern ptr hash_found;
     q=p;
  again:
     q=index(q,':');
    if(q==NULL){
       psh(x=GMAKESTR(p,c));
       x=intern(x,a_unbdd);
       pull();
       return x;
     }
    r=esc_tokstr;  /***  ***/
    if(*(r+(q-p))=='Y')
      {
         q=q+1;
         goto again;
      }
    if(q==p)
         {
          /** keyword **/
          /** return ex_intern(p+1,a_keyword); とりあえず**/
            psh(x=GMAKESTR(p,c));
              x=key_intern(x);
           pull();
            return x;
           /** return a_undef; ***/
         }
    else
         {
           x=GMAKESTR(p,q-p);
            pack=find_package(x); 
           /**  prin1(pack,STDOUT);  **/
           if(pack==a_f)
               error(E_access,x);
           if(*++q!=':'||*(r+(q-p))=='Y')
            {
             ret=ss_find_symbol(x=CMAKESTR(q), pack);  /*** external ?  ***/
             if(ret==a_f) {
                  psh(x);
                  ret= in_intern(x,pack,a_unbdd);
                  pull();
                /*** error(E_access,x);  ***/
               }
             return ret;
            }
           else{
             ret=ss_find_symbol(x=CMAKESTR(q+1), pack);  /*** external ?  ***/
             if(ret==a_f){
                  psh(x);
                  ret= in_intern(x,pack,a_unbdd);
                  pull();
                 /**  error(E_access,x);  **/
             }
             return ret;
             /** error(E_illegal,CMAKESTR(p)); **/
             /** return intern(MAKESTR(q+1),pack); **/
             return intern_c(q,a_nil) ;/*** とりあえず  **/
             }
         }
}         


