;;; R-reduce-min.ss
;;;   if R-minct>0
;;;; then we can omit back-init and back
;;;;
(in-package "regexp")

(define (R-red-*  top x rest )
   (let* ((n (R-minct (cadr x))))
        (if (> n 0)
              (R-red-*-min  top x rest )
              (R-red-*-safe  top x rest )
        )
))

(define (R-red-+  top x rest )
   (let* ((n (R-minct (cadr x))))
        (if (> n 0)
              (R-red-+-min  top x rest )
              (R-red-+-safe  top x rest )
        )
))


(define (R-red-*-safe  top x rest )
   (let* ((f 0)(c 0)(C 0)(d 0)(D 0))
             (set! C *state-num*)
                (set! f (list C))
               (if (not (eq? top :*?))
                (set! c  (list (list 'back f) (list :or (append  (cadr x) C) rest)))
                (set! c  (list (list 'back f) (list :or rest (append  (cadr x) C))))
                )
                (set! C (force-new-state c)) ;;; must same C
                (R-red c)
                (set! D (R-red  (list (list 'back-init f))))
                (cons (get-link D) C)
))

(define (R-red-*-min  top x rest )
   (let* ((f 0)(c 0)(C 0)(d 0)(D 0))
             (set! C *state-num*)
               (if (not (eq? top :*?))
                (set! c  (list  (list :or (append  (cadr x) C) rest)))
                (set! c  (list  (list :or rest (append  (cadr x) C))))
                )
                (set! C (force-new-state c)) ;;; must same C
                (R-red c)
))

(define (R-red-+-safe top x rest )
   (let* ((f 0)(c 0)(C 0)(d 0)(D 0))
                (set! C *state-num*)
                 (set! f (list C))
                 (if (not (eq?  top :+?))
                   (set! c  (append  (cadr x) (list (list :or  C rest   ))))
                   (set! c  (append  (cadr x) (list (list :or  rest  C ))))
                 )
                 (set! c  (cons  (list 'back f) c))
                (set! C (force-new-state c)) ;;; must same C
               ;;;; (format #t ":+ new  C ~s ~%" C)
                (R-red c)
                (set! D (R-red  (list (list 'back-init f))))
                (cons (get-link D) C)
))

(define (R-red-+-min top x rest )
   (let* ((f 0)(c 0)(C 0)(d 0)(D 0))
                (set! C *state-num*)
                 ;;;;(set! f (list C))
                 (if (not (eq?  top :+?))
                   (set! c  (append  (cadr x) (list (list :or  C rest   ))))
                   (set! c  (append  (cadr x) (list (list :or  rest  C ))))
                 )
                 ;;;(set! c  (cons  (list 'back f) c))
                ;;;;;(set! C (force-new-state c)) ;;; must same C
               ;;;; (format #t ":+ new  C ~s ~%" C)
                (R-red c)
                ;;;(set! D (R-red  (list (list 'back-init f))))
                ;;;;(cons (get-link D) C)
))

