;;;;   ftp-win
;;;;
(in-package "get-file")

(load "files-win")

(define (sftp-win)
  (let* ((top (gen-toplevel '.sftp))
         (fl (tk-name top '.fl))
         (mv (tk-name top '.mv))
         (fr (tk-name top '.fr))
         (local 0)
         (remote 0)
        )
  (wm 'title  top (tk-string *session* "       " *access*))
  (frame fl)
  (frame mv)
  (frame fr)
  (set! local (make-local-files fl))
  (set! remote (make-remote-files fr))
  (make-move-win mv local remote)
  (grid fl mv fr)
  top
))

(define (make-move-win fr local remote)
  (let*  (  (local_lab (tk-name fr '.loc))
            (reset (tk-name fr '.reset))
            (status (tk-name fr '.state))
            (keep  (tk-name fr '.keep))
            (remote_lab (tk-name fr '.remo))
            (local_copy (tk-name fr '.loccp))
            (remote_copy (tk-name fr '.remocp))
            (local_move (tk-name fr '.locmv))
            (remote_move (tk-name fr '.remomv))
            (sp (tk-name fr '.space))
            (quit      (tk-name fr '.quit))
         )
    (button reset :text "Reset" :command (lambda()(reset-sftp local remote)))
    (checkbutton keep :text "attr-P" :variable '*-P* 
       :onvalue "-P " :offvalue "" )
    (funcall keep 'select)
    (label status :text "status" :relief 'solid)
     (set! *status* status)
    (label local_lab :text "files")
    (label remote_lab :text "files")
    (label sp :text "")
    (button local_copy :text "  >>" :command 
           (lambda () (copy_local local remote)) )

    (button remote_copy :text "<<  " :command
           (lambda () (copy_remote local remote)) )
     (button local_move :text "==>>" :command
           (lambda () (move_local local remote)) )
                                                                                         
    (button remote_move :text "<<==" :command
           (lambda () (move_remote local remote)) )
    (button quit  :text "exit" :activebackground 'red 
            :command (lambda()(send-msg "exit")
          (if (not (process-exited? *pid*)) (kill *pid*))
          ;;;(format #t "buf:~s~%res:~s~%" (list->string (reverse *buff*)) *res*)
          (bye)))

    (grid reset)
    (grid status)
    (grid keep)
    (grid local_lab)
    (grid local_copy)
    (grid local_move)
    (grid remote_lab)
    (grid remote_copy)
    (grid remote_move)
    (grid sp )
    (grid quit )
))

