#|
   GUI sftp
   2005.3.17
   FIFO is bad....
   may be  sftp is special?  No,  BUFSIZE
  sftp give up to write over 4096 bytes!

   net-run version
|#

(in-package "get-file")

(kanji-mode #f)

(define *echo* #t)  ;;;;  #t for display sftp sesssion

(define *pid* 0)
(define *in-f*   0 )
(define *out*   0 )

(define *read-exit* #f)
(define *read-busy* #f)

;;;(define pid (net-run  "sftp" "sato@random") )
(define (run-sftp)
 ;;;(let* ((pid (net-run "sftp" *access*) ))
  (let* ((pid (net-run  "bash" "-c" (tk-string "sftp " *access*) )))
   (set! *in-f* (cdr pid))
   (set!  *out* (cdr pid))
   (set! *pid* (car pid))
))

(define *buff* ())  ;;; for debug
(define *res* ())  ;;; for debug

;;;***  prompt cause hang up for read-line
(define *sftp-prompt* (reverse (string->list "sftp> ")))

(define (write-status x . color)
   (if (pair? color)
      (funcall *status* 'configure :text x :background (car color))
      (funcall *status* 'configure :text x)
  )
)

(define (reset-sftp local remote)
       (set! *read-exit* (lambda()  (dir-reset local)(dir-reset remote)))
        (if *echo*  (format #t "reset busy ~a ~a~%" *read-busy* *read-exit* ))
   (if (not *read-busy* ) 
       (funcall  *read-exit*)
   )
)
(define (wait-recv str)
   (let* ((in *in-f*)(x #\a)(buf ())(s 0)(quit #f))
     (if *echo* (format #t "wait-recv str ~a~%" str))
    (while   (not quit)
          (set! x (read-char in))
          (if (eof-object? x)
                (begin
                      (set! quit #t)
                      (close-port in)
                )
              (begin
                (if (eq? x #\newline)
                   (begin
                      (set! s (list->string (reverse buf)))
                      (format #t "wait-recv:~a~%" s)
                      (set! quit #t)
                   )
                  (push x buf)
                )
             )
         )
    )
     (if *echo* (format #t "wait-recv end s ~a  eual? ~s ~%" s   (equal? str s)))
  (equal? str s)
))


(define (send-msg str)
  (let* ((res #f))
  (if (closed-port? *out*) (bye))
  (format *out*  "~a~%" str)
 ;;; (format *out*  "~a~%~%" str)
  (flush *out*)
      ;;;(format #t "send:~a~%" str)
  (after 200)
  (if  (equal? str "exit")
       (bye)
    (begin
      (set! res (wait-recv (tk-string "sftp> " str)))
      (if *echo*
        (if res
         (begin
            (format #t "OK! ~s sent by send-msg ~%" str)
            ;;;   (print-get *in-f*)
         )
          (format #t "FAILED! ~a sent ~%" str)
        )
       ) 
     )
  )
))

(define (read-p )
  (let* ((x #\a)(in *in-f*) (res ()) (buf ())(s 0)(quit #f)(count 0))
      (write-status "Working..."  'blue)
      (set! *read-busy* #t)
      (set! *read-exit* #f)
    (if *echo* (format #t "read-p-2 Enter~%"))
    (when (not (char-ready? in))
        (after 100)
        (set! count 3)
    )
    (while (not quit)
         (update)
         (after 100)
         (inc count)
         (set! quit *read-exit*)
         (when (>  count  5)
            (set! count 0)
    (if *echo* (format #t "read-p-2 send newline~%"))
            (newline *out*)
         )
      (while   (char-ready? in )
          (set! x (read-char in))
   ;;; (if *echo* (format #t "read-p-2 read-char:~s~%" x))
    (flush)
          (if (eof-object? x)
                (begin
                      (set! quit #t)
                      (close-port in)
                )
              (begin
               ;;; (format #t "~a" x )
                (if (eq? x #\newline)
                  (begin
                      (set! s (list->string (reverse buf)))
                      (set! buf ())
                      (format #t "recv:~s~%" s)
                      (push s res)
                         (set! quit res)
                        (when (not (char-ready? in))
                         (after 100)
                         (when  (not (char-ready? in))
                            (set! quit 'res)
                           ;;;(set! count 9)
                         )
                        )
                  )
                 (begin
                     (push x buf)
                    (when (equal? buf *prompt*)
                         (if (char-ready? in)
                              ( format #t "cont-recv:sftp> ")
                             (begin
                               (set! quit 'res)
                               ( format #t "prompt-recv:sftp> ")
                             )
                         )
                    )

                  )
                )
              )
           )
    )
   )
  (flush)
  (ready-check)
  (write-status "OK" 'green)
  (when *read-exit* (funcall *read-exit*))
   (update)
   (set! *read-busy* #f)
  (if (eq? quit 'res)
           res
           quit
   )
))

(define (ready-check)
   (newline *out* )
   (wait-recv "sftp> ")
) 

(define (remote-glob . ext)
   (send-msg "ls")
   (read-p)
)

(define (remote-pwd)
  (let* ((s 0)(n 0))
   (send-msg "pwd")
   (set! s (read-p))
   (set! s (car s))
   (set! n (string-index ":" s))
   (substring s (+ n 2) :end)
))

(define (remote-chd dir)
  (let* ((s 0)(n 0))
   (send-msg (tk-string "cd " dir))
   (read-p)
   dir
))
