#|
   GUI sftp
   2005.3.17
   FIFO is bad....
   may be  sftp is special?  No,  BUFSIZE
  sftp give up to write over 4096 bytes!

   net-run version
|#

(in-package "get-file")

(kanji-mode #f)

(define *echo* #t)  ;;;;  #t for display sftp sesssion

(define *pid* 0)
(define *in-f*   0 )
(define *out*   0 )

(define *read-exit* #f)
(define *read-busy* #f)

;;;(define pid (net-run  "sftp" "sato@random") )
(define (run-sftp)
 (let* ((pid (net-run "sftp" *access*) ))
 ;;; (let* ((pid (net-run  "bash" "-c" (tk-string "sftp " *access*) )))
   (set! *in-f* (cdr pid))
   (set!  *out* (cdr pid))
   (set! *pid* (car pid))
))

(define *buff* ())  ;;; for debug
(define *res* ())  ;;; for debug

;;;***  prompt cause hang up for read-line
(define *sftp-prompt* (reverse (string->list "sftp> ")))

(define (write-status x . color)
   (if (pair? color)
      (funcall *status* 'configure :text x :background (car color))
      (funcall *status* 'configure :text x)
  )
)

(define (reset-sftp local remote)
       (set! *read-exit* (lambda()  (dir-reset local)(dir-reset remote)))
        (if *echo*  (format #t "reset-sftp ~%" ))
    (if (not *read-busy*) (funcall *read-exit*))
)

(define str-buf "test")
(define str-port (open-output-str str-buf))
(close-port str-port)

(define (getchar in)
   (let* ((x #f))
     (while (not x)
        (if (char-ready? in)
            (set! x (read-char in))
            (begin
           (set!  *read-busy* #t)
               (after 200)
               ;;;(display ".")
               (flush)
               (update)
            )
        )  
       (when (closed-port? in)
         (format #t "**** connection closed!!!***~%")
         (bye)
       )
     )
  (set!  *read-busy* #f)
   x
))

(define (recv-str)
   (let* ((in *in-f*)(x #\a) (s 0)(quit #f)
     (p (reopen-str str-port )))
     ;;;(if *echo* (format #t "recv-str~%"))
    (while   (not quit)
          (set! x (getchar in))
          (if (eof-object? x)
                (begin
                      (set! quit #t)
                      (close-port p)
                      (close-port in)
                )
              (begin
                (if (eq? x #\newline)
                   (begin
                      (set! s (close-port p))
                      (format #t "recv-str:~a~%" s)
                      (set! quit #t)
                   )
                  (display x p)
                )
             )
         )
    )
   (set! str-port p)
  s 
))

(define (wait-recv str)
   (let* ( ( s (recv-str)))
     ;;;(if *echo* (format #t "wait-recv end s ~a  eual? ~s ~%" s   (equal? str s)))
  (equal? str s)
))

(define (read2prompt)
   (let* ( (s 0)(quit #f)(res ()))
    ;; (if *echo* (format #t "read2prompt enter~%" ))
    (while   (not quit)
          (set! s (recv-str ))
          (cond ((equal? s "sftp> ")  
                   ;;(format #t "read2prompt end:~a~%" s)
                   (set! quit #t) )
                ((equal? s "") )
                (else (push s res)
                   ;;; (if *echo* (format #t "read2propmpt:~a~%" s))
                )
          )
    )
     ;;;(if *echo* (format #t "read2prompt end~%" ))
  res
))


(define (send-msg str)
  (let* ((res #f))
  (if (closed-port? *out*) (bye))
  (format *out*  "~a~%" str)
 ;;; (format *out*  "~a~%~%" str)
  (flush *out*)
      ;;;(format #t "send:~a~%" str)
 ;;;; (after 100)
  (if  (equal? str "exit")
       (bye)
    (begin
      (set! res (wait-recv (tk-string "sftp> " str)))
      ;;;(set! res #t)
      (if *echo*
        (if res
         (begin
            (format #t "OK! ~s sent by send-msg ~%" str)
            ;;;   (print-get *in-f*)
         )
          (format #t "FAILED! ~a sent ~%" str)
        )
       ) 
     )
  )
))

(define (read-p)
  (let*  ((s 0))
   (write-status "Working..."  'blue)
    (newline *out*)
    (update)
    (set! s (read2prompt))
   (write-status "OK" 'green)
    (update)
  s
 ))


(define (remote-glob . ext)
   (send-msg "ls")
   (read-p)
)

(define (remote-pwd)
  (let* ((s 0)(n 0))
   (send-msg "pwd")
   (set! s (read-p))
   (set! s (car s))
   (set! n (string-index ":" s))
   (substring s (+ n 2) :end)
))

(define (remote-chd dir)
  (let* ((s 0)(n 0))
   (send-msg (tk-string "cd " dir))
   (read-p)
   dir
))
