;;;;   shuffle  file ...
;;;
(load "shuffle")

(define (make-rand file)
   (let* ((e (get-file-ext file)))
     (if e
       (string-append (car e) "-rand" (cdr e))
       (string-append file  "-rand" )
     )
))
      
(when (pair? *argv*)
  (let* ((f 0) (in 0)(out 0))
     (while (pair? *argv*)
       (set! f (pop *argv*))
       (set! in (open-input-file f))
         ;;;(set! f (string-append f "-rand"))
         (set! f (make-rand f ))
         (set! out (open-output-file f))
       (when (and in out)
         (shuffle-file in out)
       )
      (close-port in) 
      (close-port out) 
     )
  (bye)
))

