;;;  computer
;;;  2003.11.5   SS version
;;;;

;;;(load "init")
;;;   0,1,...14 are number 15 is blank
(define *ban* (make-vector 16))  ;;; 
(define *pos* (make-vector 16))
(define *delo* 0)
(define *count* 0)
(define *goal* 0)
;;;;;  initialize
(define (init-ban)
  (do ((i 0))
    ((= i 16) )
    (vector-set! *ban* i  i )
    (vector-set! *pos* i  i )
    (set! i (+ i 1))
  )
 (set! *goal* (vector-copy *ban*))
)

;;;;;;;;;;;;;;;;;;gyouܤn뤫Ƚ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;   return 0  for n=0-3, 1 for 4-7,...
(define (get-row n)
      (floor (/  n  4)) )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;    shuffle even(100)  permutation!! for 15-puzzle
;;;;  last 15 is unchanged
;;;;
(define (15shuffle)
   (init-ban)
   (let ((i 0)(j 0))
     (do ((n  0))
         ((= n 100) )
          (set! i (random 15))
          (set! j (random 15))
          (when  (not (= i j) ) 
            (change-pos i j)
            (set! n (+ n 1))
          )
    )
))         

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;ban ijȸ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (change-pos   i j)
  (let ((x 0)(y 0))
      (set! x (vector-ref *ban* i))
      (set! y (vector-ref *ban* j))
      (vector-set! *ban* i y)
      (vector-set! *ban* j  x)
      (vector-set! *pos* x j)
      (vector-set! *pos* y i)
))  
;;;;;;;;;;;;;;15ѥξ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (change-clear)
   (let ((i 0) (j 0) (y 0) (fr 0) (bt 0))
    (do 
       ((i 0 (+ i 1)))
       ((= i 4))
       (set!  fr (tk-name ".delo"  ".f" i))
       (do 
          ((j 1 (+ j 1)))
          ((= j 5))
          (set! bt (tk-name fr ".b" y))
          (eval`(,bt 'configure :text "clear!!!"
                                :command "exit"
                                :relief 'flat
                )
            ()
          )     ;;;   needs () for ss
          (set! y (+ y 1))
       )
     )
    )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (button-name i)
       (tk-name  ".delo.f" (get-row i) ".b" i))
  
(toplevel '.delo)
(define (restart)
  (let ((x 0) (y 0)  (n 0)  (bt 0) (fr 0))
        (15shuffle)
        (set! x (vector->list *ban*))
        (do
            ((i 0 (+ i 1)))
            ((= i 4))
            (do
               ((w 1 (+ w 1)))
               ((= w 5))
               (set! bt (button-name  y))
               (set! n (+ (pop x)1))
               (format #t "~s ~%" bt)
               ((eval  bt ()) 'configure
                        :text (if (= n 16)
                                   " "
                                   n
                              )
                        :relief (if (= n 16)
                                   'flat
                                   'raised
                                )
               )
               (set! y (+ y 1))
             )
         )
     (set! *count* 0)
       (.delo.count 'configure :text  "COUNTER")
 ))

(define (start)
      (let ((x 0) (y 0)  (n 0)  (bt 0) (fr 0))
        (15shuffle) 
        (set! x (vector->list *ban*))
	(do
            ((i 0 (+ i 1)))
            ((= i 4))
            (format #t "i: ~s~%" i)
            (set!  fr (tk-name  ".delo.f" i))
            (frame fr)
            (pack fr :side 'top)
            (do
               ((w 1 (+ w 1)))
               ((= w 5))
               (set! bt (button-name  y))	
               (set! n (+ (pop x)1))
               (format #t "~s ~%" bt)
               (button bt
                        :text (if (= n 16)
                                   " "
                                   n
                              ) 
                        :relief (if (= n 16)
                                   'flat
                                   'raised
                                ) 
                        :height 3
                        :width 6
                       ;:border 0
                       ;:padx 0 :pady 0
                        :command `(idou  ,bt ,y)
               )
               (pack bt :in fr :side 'left)
               (set! y (+ y 1))
             )
	 )
       (button '.delo.exit :text "EXIT" :command "exit")
       (button '.delo.reset :text "RESET" :command '(restart))
       (label '.delo.count :text "COUNTER")
       (pack .delo.count .delo.reset .delo.exit)
       (set! *count* 0)
       )
)
(define (idou  b c)
  (let ((delo 0) (pat 0) (pos16 (vector-ref  *pos* 15)))
   
   (set! *delo* (tk-name ".delo"  ".f" (get-row pos16) ".b"  pos16) )
    (format #t "~s ~%" b)
   ;;;    (format #t "~s ~%" delo)
    (format #t "~s ~%" *ban*)

  (set! pat (modulo c 4))   ;;;  0  is left edge, 3 is right edge
   (cond ((= pat 0)
            (if(= (+ c 1) pos16) (sousa b c)))
        ((= pat 3)
             (if(= (- c 1) pos16) (sousa b c))  )
        (#t 
              (if(= (+ c 1) pos16) (sousa b c))
              (if(= (- c 1) pos16) (sousa b c))
         )
   )
  (if(= (+ c 4) pos16) (sousa b c ))
  (if(= (- c 4) pos16) (sousa b c))
))

(define (get-pos x)
  (vector-ref *pos* x)
)

(define (sousa b c)
     (eval`(,b 'configure :text " " :relief 'flat) ())
     (eval`(,*delo* 'configure :text (+ ,(vector-ref *ban*  c ) 1) :relief 'raised) ())
     ;(set! *ban* (change16 *ban* (vector-ref *ban*  c )))
     (change-pos c (get-pos 15))
     (set! *count*  (+ *count* 1))
     (.delo.count 'configure :text *count*)
     (format #t "~s ~%" *ban*)
     (hyo)
     (format #t "~s ~%"
     (if (equal? *ban* *goal*) (change-clear) "no!!"))
   )
   ;;;

(define (enable)
  (let ((res ()) (pat 0) (c 0)(pos16 (vector-ref  *pos* 15)))

  (set! pat (modulo pos16 4))   ;;;  0  is left edge, 3 is right edge
  (set! c (+ pos16  4))
  (if (< c 16) (push c res))
  (set! c (-  pos16  4))
  (if (>= c 0) (push c res))
  (set! c (+ pos16  1))
  (if (< pat 3) (push c res))  
  (set! c (- pos16  1))
  (if (>  pat 0) (push c res))  
  res
))

(define (hyouka v)
  (let ((s 0)(x 0)(k 1))
    (do ((i 0 (+ i 1)))
        ((= i 16) s)
        (set! x (vector-ref v i))
        ;(cond  
        ;      ( (< x 4) (set! k 2))
        ;      ( (< x 8) (set! k 1))
        ;      ( (< x 12) (set! x 0.5))
        ;      (else  (set! x 0.25))
        ;)
        (set! k x)
        (if (= x 15) (set! x 0) 
            (set! x (- x i)) )
        (set! s (+ s (* k x x)))
    )
))

(define (hyo)
  (let ((te (enable))(x 0)(v 0)(vmin  100000)(pos16 (vector-ref  *pos* 15)))
    (while (pair? te)
       (set! x (car te))
       (change-pos x pos16)
       ;;(format #t "te ~s  value ~s ~%" x (hyouka *ban*))
       (set! v (hyo-rec 3))
       (format #t "te ~s  value ~s ~%" x v)
       (change-pos  x pos16)
       (if (< v  vmin) (set! vmin v))
       (set! te (cdr te))
   )
  vmin
))


(define (hyo-rec level)
  (let ((te (enable))(x 0)(v 0)(vmin  100000)(pos16 (vector-ref  *pos* 15)))
    (if (= level 0)
      (set! vmin  (hyouka *ban*))
      (while (pair? te)
       (set! x (car te))
       (change-pos x pos16)
       ;;(format #t "te ~s  value ~s ~%" x (hyouka *ban*))
       (set! v (hyo-rec (- level 1))) 
       (change-pos  x pos16)
       (if (< v  vmin) (set! vmin v))
       (set! te (cdr te))
     )
  )
  vmin
))     

(start)

