;;;  ŻҲ   multi-client server
;;;  2004.7.16
;;;;

(define net (netport 50000))

(define (server)
  (let* ((name 0)(acc 0)(n 0)(clients ()) (person 0)(msg 0) (listen-soc 0))
     (format #t "waiting connection on ~s ~s ~%" (netport-number net) (netport-hostname net) )
     (set! listen-soc (socket-listen net))
     (set! acc (socket-accept listen-soc)) ;;; wait first client
     (inc n)
     (set! name (read-line acc))
     (format acc "Welcome ~a! you are the first member, Please Wait~%" name)
     (push (cons name acc) clients)
     (while (> n 0)
         (when  (char-ready? listen-soc)    ;;;;  New member coming?
             (set! acc (socket-accept listen-soc)) 
             (set! name (read-line acc))
             (send-msg  "Hello!" name clients)  ;;; greeting
             (push (cons name acc) clients)
             (inc n)
             (format acc "Welcome you are ~s st member~%" n)
             (format acc "Now members are ~s~%" (map car clients))
         )
         (do ((all clients ))
             ((null? all))
             (set! person (pop all))
             (set! name (car person))
             (set! acc (cdr person))
             (when (char-ready? acc)    ;;; msg coming?
                 (set! msg (read-line acc))
                 (if (eof-object? msg)
                     (begin            
                       (close-port acc)   ;;; this member is out!
                       (set! clients (remove person clients))
                       (dec n)
                     )
                     (begin
                      (send-msg msg name (remove person clients))
                      (format #t "recv: from ~a > ~a ~%" name msg)
                      ;;;(format #t "recv: ~s ~%" (map char->integer (string->list msg)))
                     )
                )
             )
         )
      )   
    (close-port listen-soc)
    (display "END!!!")
))

(define (send-msg msg name others)
   (while (pair? others)
       (format (cdr (pop others)) "~a>> ~a~%" name  msg)
   )
) 

(server)
