/***   funcall.c
   03.12.21
   from sseval.c   
   for MC  code
***/

#define FUNCALL

#include "lisp.h"

extern ptr k_Q,*MPC,k_F;

extern PUSH_REG();
extern ptr scm,*mpu_stack,*pc_stack,M(),M_exp(),M_mc();
extern int narg,level,evalflag;
#define MPUSH(x)  (*mpu_stack++=(x))
#define MPULL  (*--mpu_stack)

ptr s_function(int narg,ptr env){
  Reg ptr func,orig;
  checknarg(narg-1);
  orig=func=*(stack-1);
 loop:
     if(SREGP(func)) error(E_nullfunc,orig);
     if(SYMBOLP(func)) {
         /***  eval  interaction , impossible && we only get global def ***/
        func=ATOMVAL(func);
        goto loop;
     }
     if(!CLOSUREP(func)) error(E_nullfunc,orig);
   return func;
}

/*** for compiler  , and more  ***/
extern ptr sr2_funcall();

ptr funcall(ptr func,int nar,ptr env){
  Reg   ptr (*addr)(),fenv,*mpc,orig;
  int type;
     orig=func;
   loop:
     if(SREGP(func)) error(E_nullfunc,func);
     if(SYMBOLP(func)) {
         /***  eval  interaction , impossible && we only get global def ***/
        func=ATOMVAL(func);
        goto loop;
     }
     if(!CLOSUREP(func)) error(E_nullfunc,orig);
   
   type=(int)FTYPE(func);
   /*** printf("funcall addr %x %d %x stack %x  ",addr ,nar,type,stack); **/

       addr=(ptr (* )())CDR(CDR(func));
       fenv=CAR(CDR(func));
      /*** if(!(type&SUBR)) return funcall_lambda(type,nar,addr,env,fenv); **/
     if(ATTR(func)==SR2) 
           return sr2_funcall(func,nar);  /*** V2.0  ***/
     if((type&ALLOC)){ 
        /***  No check lambda! used by macroexpand ***/
       /**  printf("funcall alloc nar  %d %x stack %x  ",nar,type,stack); ***/
        /*** Why cn)t trace ??? **
           MPUSH(func);
          MPUSH(k_F);
         ***/
       
          PUSH_REG();
          MPUSH(k_Q);
          func=CDR(func);
          narg=nar;
          a_env=CAR(func);
          mpc=MPC;
          /***  MC(0) needs????  as mc_eval   ****/
          MC(0);
          scm=MC(CAR(CDR(func)));
          jmp_level--;
          MPC=mpc;
          return scm;
          /*** return mc_evalfunc(func); ***/
      } 
     else if(type&LAMBDA){   /***  compiled system lambda   ***/
               scm=(* addr)(nar,fenv);  /**** ???? ***/
               return scm;
      }
     else{   /*** macro  subr  to be modify!!! ***/
         psh(func=(* addr)(nar,fenv));
         /*** func=eval(func,env); ***/
         func=meval(func,env); 
            /*** stack-=narg; ***/
        return func;
    }
}
/*** this version  do well, but cat't trace also! Why??????  
ptr s_funcall(int nar,ptr env){
 ptr f;
 int type;
  if(nar==0) checknarg(-1);
  f=*(stack-nar);
  type=(int)FTYPE(f);
  narg--;
 if(type&ALLOC){
    MPUSH(f);
    MPUSH(k_F);
    PUSH_REG();
    MPUSH(MC_adress(f));
    return scm;
}
else{
   mc_jsr(f);
}
  return scm;
}
****/

ptr s_funcall(int nar,ptr env){
  if(nar==0) checknarg(-1);
  return funcall(*(stack-nar),nar-1,env);
}
