/****
   ms.c
   03.12.21
   compiler control  function's
****/
#define MS_C

#include "lisp.h"

extern ptr OUTCOMP[],*MPC;

ptr s_mcompile(int narg,ptr env){
 ptr s,v;
 int n;
   checknarg(narg-2);
   v=s_compile(2,a_nil);
   psh(v);

   delete_warn(v);
   delete_nop(v);
   final_comp(v);

   if_syori(v);
   n=sr_out(v);

   s=comp_to_alloc(OUTCOMP,n); /** make MC **/
           #ifdef DEBUG
  lwritestr(STDOUT,"mcompile comp to alloc OK");
   newline(STDOUT);
  #endif

   pull();
   return s;
}

/***  eval given s,  by compiler !!!  ***/
ptr meval_orig(ptr s,ptr env){   /***   eval   ***/
  ptr *mpc;
  mpc=MPC;
  /***  printf("meval start MPC %x\n",MPC); ***/
  psh(s);
  psh(env);
  s=s_meval(2,a_nil);
  stack-=2;
  MPC=mpc;
  /*** printf("meval out MPC %x\n",MPC); ***/
  return s;
}

ptr meval(ptr s,ptr env){   /***   eval   ***/
  ptr *mpc;
  mpc=MPC;
  /***  printf("meval start MPC %x\n",MPC); ***/
  psh(s);
  psh(env);
   s=s_mcompile(2,a_nil);
  #ifdef DEBUG
  lwritestr(STDOUT,"meval mcompile OK");
   newline(STDOUT);
#endif

   *(stack-2)=s;
   s=s_mc_eval(2,*(stack-1)); /*** a_nil ?  ***/
  #ifdef DEBUG
  lwritestr(STDOUT,"meval mc_eval OK");
   newline(STDOUT);
#endif
  stack-=2;
  MPC=mpc;
  /*** printf("meval out MPC %x\n",MPC); ***/
  return s;
}

ptr s_meval(int narg,ptr env){
  ptr s;
   checknarg(narg-2);
   s=s_mcompile(2,a_nil);
   *(stack-2)=s;
   s=s_mc_eval(2,*(stack-1)); /*** a_nil ?  ***/
   return s;
}
  

