/***   append.c ***/

#define  APPEND_C

#include "lisp.h"

extern int setpara();
extern ptr last_pair();

ptr append(Reg ptr x, Reg ptr y){
Reg ptr *sfree;
int n,m;
if(x==a_nil) return y;
if(y==a_nil) return x;
m=n=setpara(x);
sfree=stack;
while(n--){
  y=(ptr)SCONS(*--sfree,y);
 }
stack=sfree;
return y;
}


ptr s_append(int narg,ptr env){
Reg ptr *sfree,x,y;

   if(narg==0) return a_nil;
   if(narg==1) return *(stack-1);
   sfree=stack;
   y=*--sfree;
   narg--;
   *stack=y;
   stack++;
 loop:
   narg--;
   x=*--sfree;
   y=*(stack-1)=append(x,y);
   if(narg){
      goto loop;
    }
   stack--;
   return y;
} 

/***  nconc ?  ***/
ptr nappend(Reg ptr x, Reg ptr y){
Reg ptr last;
int n,m;
if(x==a_nil) return y;
if(y==a_nil) return x;
last=last_pair(x);
if(last==a_f) error(E_notlist,x);
CDR(last)=y;
return x;
}


ptr s_nappend(int narg,ptr env){
Reg ptr *sfree,x,y;
   if(narg==0) return a_nil;
   if(narg==1) return *(stack-1);
   sfree=stack;
   y=*--sfree;
   narg--;
 loop:
   narg--;
   x=*--sfree;
   y=nappend(x,y);
   if(narg){
      goto loop;
    }
   return y;
}



