
#include "lisp.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
/*  89.6.15 format.c start */
/*  89.7.11 formsk.c start
          ****/

#define  KANJIP(x)   (kanji_mode&&((x)&0xff)>127)
     
#define kolon (modeb&1)
#define atto  (modeb&2)
    
extern  Uchar *modef();
Uchar *sfpara();

/*** (C-printf ctrl float)   C-print,  return string, Only real float  ***/
static char C_printf[512];
ptr s_cprintf(int narg,ptr env){
  ptr ctrl,x;
  char *p,*pf;
  int n;
  checknarg(narg-2);
  ctrl=*(stack-2);
   x=*(stack-1);
     p=get_string(ctrl,&n);
     sprintf(C_printf,p,get_float(x));
    n=strlen(C_printf);
   x=makestring(n);
     p=get_string(x,&n);
     pf=C_printf;
    while(n--){
      *p++=*pf++;
    }
   return x;
}

void mode_print(ptr p){
  int modeb;
   modeb=GETNUM(p);
   pr_cstr(STDERR,"modifier ");
   if(modeb&1) pr_cstr(STDERR,":");
   if(modeb&2) pr_cstr(STDERR,"@");
   if(modeb&4) pr_cstr(STDERR,"!");
   newline(STDERR);
}

ptr form_err(int s,ptr p){
  pr_cstr(STDERR,"Format error!\n");
  switch(s){
      case  E_fm_mode: mode_print(p);
           break;
     default: break;
  }
  error(s,p);
  return a_nil; //Never
}
  

    /** kanji_mode=(CAR(a_kanji)!=a_nil); *****  kanji 89.8.30****/
 
