/*** number_str.c
***/
#define  NUMBER_STR

#include "lisp.h"
#include <stdio.h>

#define format(p,obj)   sprintf(iobuff,p,obj)
extern mpz_t mpzwork1;


ptr number2str(Reg ptr q,int base){
Reg int n;
Reg ptr u;
Reg   char *pp;

/*** printf("number2 %x  base %d\n",q,base); ***/
if(base>32) error(E_range,MAKESINT(base));

if(SREGP(q)){
   if(CHARP(q)) goto err;
   if(base==10){
       format("%d",(int)SINT_NUMB(q));
       return CMAKESTR(iobuff);
     }
   else{
    mpz_set_si(mpzwork1,(int)SINT_NUMB(q));
     pp=mpz_get_str(0,base,mpzwork1);
          q=CMAKESTR(pp);
          Myfree(pp);
          return q;
     }
  }
n=ATTR(q);
       if(n&BIGINT){
          psh(q);
          pp=mpz_get_str(0,base,BIGNUM(q));
          q=CMAKESTR(pp);
          Myfree(pp);
          pull();
          return q;
        }
       else if(n&RATIO){
           psh(q);
           pp=mpq_get_str(0,base,RATIONAL(q));
           q=CMAKESTR(pp);
          Myfree(pp);
          pull();
          return q;
        }
      else if(n&DOUBLE){
           /** format("%f",FLONUM(q)); ***/
           format("%-11.8g",FLONUM(q));
           force_float(iobuff);
            return CMAKESTR(iobuff);
       }
      else if(n&COMPLEX){
           /** prin_s("#c("); **/
          if(CAR(q)!=ZERO)
              u=number2str(CAR(q),base);
           else 
              u=a_nullstr;  /** CMAKESTR(""); ***/
          psh(u);
          q=CDR(q);
           if(gsign(q))
               u=str_append(u,CMAKESTR("-i"));
           else
               u=str_append(u,CMAKESTR("+i"));
           *(stack-1)=u;
           psh(q=ABS(q));
           if(q!=ONE){
              u=number2str(q,base);
              psh(u);
               u=str_append(*(stack-3),u);
              pull();
            }
          stack-=2;
          return u;
      }
err:
     error(E_notnum,q);
}           

ptr s_number2str(int narg,ptr env){
  int base;
  if(narg==1)
          base=10;
  else if(narg==2) base=SINT_NUMB(*(stack-1));
  else
      checknarg(narg-2);
  return number2str(*(stack-narg),base);
}


