/*** pathname.c
  05.3.11 created
 ***/
#define  PATHNAME_C

#include "lisp.h"
#include <string.h>


static char pathname[500];

ptr sspathname_base(ptr file){
   ptr name,new;
  char c,*p,*q,*r;
  int n;
    p=(char *)get_string(file,&n);
    if(*p=='/') /*** UNIX abs path ***/
     {
        return file;
     }
 if(*p=='~'){  /*** user HOME   ~sato   ***/
    if(*(p+1)=='/'){
      q=(char *)get_string(CAR(a_home),&n);
      strncpy(pathname,q,n);
      strncpy(pathname+n,p+1,499-n);
      new=make_str_c(pathname);
      return new;
     }
    q=p;
    r=pathname;
    while(((c=*q)!='/')&&(n-->0)){
        *r++=c;
        q++;
     }
     *r=0;
     if(c=='/') q++;
     new=glob_files(pathname,a_nil,0);
     if(new==a_nil) return a_f;
     name=CAR(new);
     strncpy(pathname,(char *)get_string(name,&n),500);
     p=pathname+n;
     *p++='/';
     strncpy(p,q,500-n);
     new=make_str_c(pathname);
      return new;
   }
   getcwd(q=pathname,500);
   n=strlen(q);
   q+=n;
   *q++='/';
   n++;
   *q=0;
  loop:
   if(*p!='.') {
        strncpy(q,p,500-n);
        new=make_str_c(pathname);
        return new;  /***  /home/sato/ss.c  ***/
    }
    c=*(p+1);
    if(c=='/'){
       p+=2;
      goto loop;
     }
    if(c=='.'){
      p+=2;
      if(*p++!='/') return a_f;
      *--q=0;
      q=rindex(pathname,'/');
      if(q==NULL) return a_f;
      *++q=0;
      goto loop; 
    }
 return a_f;  /*** never reach  ***/
}
   
/***  if file is directory  add /  ***/ 
static ptr sspathname(ptr file){
  char *p;
  int n;
  file=sspathname_base(file);
  p=(char *)get_string(file,&n);
  if(*(p+n-1)=='/') return file;
  if(!is_directory(p)) return file;
  psh(file);
  strncpy(pathname,p,n);
  p=pathname+n;
  *p++='/';
  *p=0;
  file=make_str_c(pathname);
  pull();
  return file;
}

ptr s_pathname(int narg,ptr env)
{
  ptr file;
  checknarg(narg-1);
  file=*(stack-1);
   if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  return sspathname(file);
}
      
char *get_ext(char *p){
 char *q,*r;
  q=rindex(p,'.');
  if((q==p)||(q==NULL)) return NULL;
  r=rindex(p,'/');   /***  for /VER2.0/test  ***/
  if(r==NULL) return q;
  if(r<q) return q;
  return NULL;
}

static ptr sepa_ext(ptr file)
{
 char *p,*q,*r;
  int n;
 ptr new;
  p=(char *)get_string(file,&n);
  q=get_ext(p);
  if(q==NULL)
    return CONS(file,a_nullstr);
  strncpy(r=pathname,p,500);
  r+=(q-p);
  *r=0;
  new=make_str_c(pathname);
  psh(new);
  file=make_str_c(q);  /***  .ss ***/
  new=SCONS(new,file);
  pull();
  return new;
}

ptr s_sepa_ext(int narg,ptr env)
{
  ptr file;
  checknarg(narg-1);
  file=*(stack-1);
   if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  return sepa_ext(file);
}

/*** /home/sato -> ("/home/" . "sato")  ***/
static ptr sepa_file(ptr file)
{
 char *p,*q,*r;
  int n;
 ptr new;
  p=(char *)get_string(file,&n);
  q=rindex(p,'/');
  if(q==NULL)
    return CONS(a_nullstr,file);
  strncpy(r=pathname,p,500);
  r+=(q-p);
  *(r+1)=0;
  new=make_str_c(pathname);
  psh(new);
  file=make_str_c(q+1);  /***  sato ***/
  new=SCONS(new,file);
  pull();
  return new;
}
                                                                                                      
ptr s_sepa_file(int narg,ptr env)
{
  ptr file;
  checknarg(narg-1);
  file=*(stack-1);
   if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  return sepa_file(file);
}

  
  
