/***  redirect.c
    2004.7.23
    stream.c  is also changed to  use read ! notgetc(fp)
***/
#include "lisp.h"
#include <stdio.h>
#include <fcntl.h>

#define FDP(path)   CADR(path)

static int red[3],fdv[3],cls[3],recistty;
static ptr  fop[3];
static ptr  std_table[3];
extern int linepos;

extern ptr cmd_exec();

void redirect_reset();
void redirect();

/***  (redirect cmds  in out sterr)  in,out,sterr may be #f ***/
/***   in, etc may be file-name   ***/
/***  We don't accept extended port without fileno  ***/
void init_redirect(){   /*** called from stream.c  ***/
   std_table[0]=a_stdin;
   std_table[1]=a_stdout;
   std_table[2]=a_stderr;
}

void check_std(){
  Reg int fd;
   if((fd=ssfileno(STDIN))!=0)
         error(E_illegal,STDIN);
   if(ssfileno(STDOUT)!=1)
         error(E_illegal,STDOUT);
   if(ssfileno(STDERR)!=2) 
         error(E_illegal,STDERR);
   return;
}


ptr s_redirect(int narg,ptr env)
{
  ptr s,cmds;
  Reg int fd,i,sameflag;
  ptr fp;  
    checknarg(narg-4);
    cmds=*(stack-4);
   /***  check_std();  ***/
    for(i=0;i<3;i++){
      fdv[i]=-1;
      fop[i]=(ptr)-1;
      cls[i]=0;
      s=*(stack-3+i);
      sameflag=0;
      if(s!=a_f){
          if(STRINGP(s)){
             if(i==0){
                  fp=open_sub(s,read_ac);
             }
             else{
                  if((i==2)&&(cls[1]==1)&&(equal(s,*(stack-2))!=a_f)){
                    /*** same file ***/
                    sameflag=2;
                    fp=fop[1];
                   }
                  else    
                     fp=open_sub(s,write_ac);
              }
              if(fp==a_f)
                     error(E_open,s);
            cls[i]=1|sameflag;
            fd=ssfileno(fp);
          }
          else if(STREAMP(s)){
                 /***  0,1,2 may be all same if net-port!!! ***/
                 if((i==1)&&(cls[0]==0)&&(equal(s,*(stack-3))!=a_f)){
                    cls[i]=2;
                    fp=fop[0];
                    fd=fdv[0];
                  }
                 else if((i==2)&&(cls[0]==0)&&(equal(s,*(stack-3))!=a_f)){
                    cls[i]=2;
                    fp=fop[0];
                    fd=fdv[0];
                  }
                 else if((i==2)&&(cls[1]==0)&&(equal(s,*(stack-2))!=a_f)){
                    /*** same stream ***/
                    cls[i]=2;
                    fp=fop[1];
                    fd=fdv[1];
                  }
                 else
                     fd=ssfileno(fp=s);
            }
          else
                 error(E_illegal,s);
         if(fd==-1) error(E_illegal,s);
            fop[i]=fp;  /*** !!! ***/
            fdv[i]=fd;  /*** !!! ***/
      }
   }
   for(i=0;i<3;i++){
         redirect(i,fop[i],fdv[i],cls[i]);
   }
   s=cmd_exec(cmds);
   redirect_reset();
  return s;
}

void redirect(int s,ptr fp,int d,int closesame)
{
   ptr sta,p;
   int up;
      /*** printf("redirect s %d fp %x d %d close %d\n",s,fp,d,closesame); **/ 
    sta=std_table[s];
     p=ATOMVAL(sta);
    if(d==-1) {
     fp=CAR(p);
     p=SCONS(SEOF,p);
     p=SCONS(fp,p);
     ATOMVAL(sta)=p;
     return;
    }
    up=dup(s);
    close(s);
    dup(d);
     p=SCONS(MAKESINT((up<<15)|(d<<2)|closesame),p);
     p=SCONS(fp,p);
     ATOMVAL(sta)=p;
     set_stream_fdp(fp,s);
    /***
     if(acc&SOCKET_PORT)
          set_socket_fdp(fp,s);
     else
           FDP(fp)=(ptr)(((int)FDP(fp)&0xffff0000)|s);  
    ***/
    /****
    if(s==0){
        recistty=istty;
        if(!isatty(s)){
           istty=0;
        }
    }
    ****/
 }

void redirect_reset()
{
  int rec,i,d,closeflag,k,acc,sameflag;
  ptr  p,fp,sta;  
  for(i=0;i<3;i++){
       sta=std_table[i];
       p=ATOMVAL(sta);
       fp=CAR(p);
       p=CDR(p);
       rec=GETNUM(CAR(p));
     if(rec!=(long)SEOF){
       close(i);
       dup(k=(rec>>15)&0x3fff);
       close(k);
       sameflag=rec&2;
       if(!sameflag){
          closeflag=rec&1;
          d=(rec>>2)&0x1fff;
          set_stream_fdp(fp,d);
           /**** FDP(fp)=((int)FDP(fp)&0xffff0000)|d;  ***/
           if(closeflag) sys_close(fp);
           /*** if(i==0) istty=recistty; ***/
           /*** printf("close %d linepos %d\n",fop[i],linepos); ***/
        }
     }
       ATOMVAL(sta)=CDR(p);
   }
}   
