/*
# Example 41-9
# Calling C command procedure directly.
# I can't do well obj type
#   So only string command use!  Sato
 */

#include "lisp.h"
#include <tcl.h>
#include <stdarg.h>
/*
* Tcl_Invoke --
* Call this somewhat like Tcl_VarEval:
* Tcl_Invoke(interp, cmdName, arg1, arg2, ..., NULL);
* Each arg becomes one argument to the command,
* with no substitutions or parsing.
*/
extern Tcl_Interp *myInterp;
extern int conv_level;

#define ECHO if(tcl_echo)

ptr
Tcl_Invoke(int narg)
{
        ptr *sfree,s;
	char *cmd,*p;						/* Command name */
	Uchar *arg;						/* Command argument */
       	char **argv;
        const char *ires;	/* interp result */
	int argc, i, max;			/* Count of arguments */
	Tcl_CmdInfo info;		/* Info about command procedures */
	int n,result;	/* TCL_OK or TCL_ERROR */

	/* interp = va_arg(pvar, Tcl_Interp *); */
        sfree=stack-narg;
        s=*sfree;
        if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
	cmd = (char *)get_string(s, &n);
	/*
	 * Map from the command name to a C procedure.
	 */
        ECHO
        fprintf(stderr," Invoke: %s ",cmd);
	if (! Tcl_GetCommandInfo(myInterp, cmd, &info)) {
                /***
		Tcl_AppendResult(myInterp, "Unknown command \"",
			cmd, "\"", NULL);
                ***/
                lwritestr(STDOUT,"**** TCL Unknown command ****\n");
		Tcl_ResetResult(myInterp);
                 error(E_tcl,*sfree);
		return a_undef;  /***  TCL_ERROR ***/
	}
	max = narg+1; /** last is NULL **/
	argc = 1;
               /** fprintf(stderr,"%s\n","type string"); ***/
		argv = (char **)Tcl_Alloc(max * sizeof(char *));
		argv[0] = cmd;
		Tcl_ResetResult(myInterp);
	/*
	 * Build a vector out of the rest of the arguments.
	 */
	while (1) {
               if(--narg==0){
                  argv[argc]==NULL;
                  break;
                 }
          s=*++sfree;
        if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
	       arg = get_string(s, &n);
	       argv[argc] = (char *)arg;
               ECHO
               fprintf(stderr,"%s ",arg);
		argc++;
	}
	/*
	 * Invoke the C procedure.
	 */
               ECHO
               fprintf(stderr,"%s\n",arg);
		result = (*info.proc)(info.clientData, myInterp,
				argc, (const char **)argv);
	/*
	 * Release our references to the arguments. 
	 */
		Tcl_Free((char *)argv);
             ires=Tcl_GetStringResult(myInterp);
             if(result!=TCL_OK) {
                 lwritestr(STDOUT,"**** TCL error ****\n");
                 lwritestr(STDOUT,ires);
                 newline(STDOUT);
                 Tcl_ResetResult(myInterp);
                 error(E_tcl,a_undef);
               }
            ECHO
            fprintf(stderr,"TCL invoke result %s\n",ires);
             s=get_ss_obj(ires,conv_level);
             ECHO
              prin1(s,STDOUT);
                Tcl_ResetResult(myInterp);
	return s;
}

ptr s_invoke(int narg,ptr env){
 char *p,*q;
 int n;
  Tcl_Invoke(narg);    /** myInterp,p,q,NULL); ***/
return a_undef;
}



